## muse 3.1.1

=== muse3/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 1999-2011 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================
project(muse)

include(FindPkgConfig)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckIncludeFiles)
include (CheckCSourceCompiles)
include(cmake/Summary.cmake)
include(CheckCXXSymbolExists)

CMAKE_MINIMUM_REQUIRED(VERSION 2.4.1)
if (COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
    cmake_policy (SET CMP0007 NEW)
endif(COMMAND cmake_policy)

if (NOT DEFINED LIB_SUFFIX)
        SET(LIB_SUFFIX "" CACHE STRING "Suffix for installed library path. Ex. 64 for lib64")
endif (NOT DEFINED LIB_SUFFIX)

SET(VST_SDK_QUIRK "")
if (NOT DEFINED VST_HEADER_PATH)
        SET(VST_HEADER_PATH "${CMAKE_CURRENT_SOURCE_DIR}/vestige" CACHE PATH "Path to vst header files (aeffectx.h). Default is ./vestige. See ENABLE_VST_VESTIGE.")
else (NOT DEFINED VST_HEADER_PATH)
    if (NOT APPLE)
        if (UNIX)
            SET(VST_SDK_QUIRK "-DVST_SDK_QUIRK") # "Building with real vstsdk under Linux requires a quirk")
        endif (UNIX)
    endif (NOT APPLE)
endif (NOT DEFINED VST_HEADER_PATH)
message(" vst header path: " ${VST_HEADER_PATH} )
include_directories(${VST_HEADER_PATH})

# set libdir if not use -DLIB_INSTALL_DIR
if (NOT LIB_INSTALL_DIR)
        if(CMAKE_INSTALL_LIBDIR)
                SET(LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR})
        else(CMAKE_INSTALL_LIBDIR)
                SET(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
        endif(CMAKE_INSTALL_LIBDIR)
endif (NOT LIB_INSTALL_DIR)

if (LIB_SUFFIX)
        message(" Install libraries to: " ${LIB_INSTALL_DIR} )
endif (LIB_SUFFIX)

IF(NOT DEFINED SHARE_INSTALL_PREFIX)
        SET(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share")
ENDIF(NOT DEFINED SHARE_INSTALL_PREFIX)

#set(CMAKE_BUILD_TYPE debug)
#set(CMAKE_BUILD_TYPE release)

# If no CMAKE_BUILD_TYPE is given on the command line,
#  cmake either uses the cached value, or 'empty' (plain un-opt build).
# And yet the only way a user can reset a cached CMAKE_BUILD_TYPE
#  is with "-DCMAKE_BUILD_TYPE=". So we cannot interfere with this.
# We should probably not attempt to do this at all.
# Installation instructions now updated to be more specific, give options.
#endif (NOT DEFINED CMAKE_BUILD_TYPE)

#UPDATE: most of users even don't know what CMAKE_BUILD_TYPE is.
#So it will be better to set unspecified build type to RelWithDebInfo
if (NOT CMAKE_BUILD_TYPE)
    message("No CMAKE_BUILD_TYPE specified. Setting to RelWithDebInfo.")
     set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif (NOT CMAKE_BUILD_TYPE)


# for debugging the make system uncomment next line:
#set(CMAKE_VERBOSE_MAKEFILE ON)

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(CMAKE_SKIP_RULE_DEPENDENCY TRUE)

# The MusE version number.
SET(MusE_VERSION_MAJOR 3)
SET(MusE_VERSION_MINOR 1)
SET(MusE_VERSION_PATCH 1)
SET(MusE_VERSION       "3.1.1")
SET(MusE_VERSION_FULL  "3.1.1")
SET(MusE_INSTALL_NAME  "muse-3.1")
SET(MusE_EXEC_NAME     "muse3")

SET(MusE_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)

## The directory where we will install the shared components:
SET(MusE_MODULES_DIR ${LIB_INSTALL_DIR}/${MusE_INSTALL_NAME}/modules)

## Synthesizers directory
SET(MusE_SYNTHI_DIR ${LIB_INSTALL_DIR}/${MusE_INSTALL_NAME}/synthi)

## Plugins directory
SET(MusE_PLUGINS_DIR ${LIB_INSTALL_DIR}/${MusE_INSTALL_NAME}/plugins)

## Audio converter plugins directory
SET(MusE_AUDIO_CONVERTER_PLUGINS_DIR ${LIB_INSTALL_DIR}/${MusE_INSTALL_NAME}/converters)

## Top documentation dir
IF(NOT DEFINED MusE_DOC_DIR)
      SET(MusE_DOC_DIR ${SHARE_INSTALL_PREFIX}/doc/${MusE_INSTALL_NAME}/)
ENDIF(NOT DEFINED MusE_DOC_DIR)

## Data directory
SET(MusE_SHARE_DIR ${SHARE_INSTALL_PREFIX}/${MusE_INSTALL_NAME})

## Lib directory
SET(MusE_LIB_DIR ${LIB_INSTALL_DIR}/${MusE_INSTALL_NAME})

include(FindGit)
if (GIT_FOUND)
      EXEC_PROGRAM( ${GIT_EXECUTABLE}
            ARGS "status"
            OUTPUT_VARIABLE GIT_RET_NOTUSED
            RETURN_VALUE IS_GIT_REPO )
    if(IS_GIT_REPO EQUAL 0)
      EXEC_PROGRAM( ${GIT_EXECUTABLE}
            ARGS "log -1 --format='%ci'"
            OUTPUT_VARIABLE MusE_GITDATE )
      EXEC_PROGRAM( ${GIT_EXECUTABLE}
            ARGS "log -1 --format='%t'"
            OUTPUT_VARIABLE MusE_GITHASH )
      EXEC_PROGRAM( ${GIT_EXECUTABLE}
            ARGS "rev-parse --abbrev-ref HEAD"
            OUTPUT_VARIABLE MusE_GITBRANCH )
      SET(MusE_GITSTRING "git: ${MusE_GITBRANCH} - ${MusE_GITHASH} - ${MusE_GITDATE}")
    else (IS_GIT_REPO EQUAL 0)
        SET(MusE_GITSTRING "")
    endif (IS_GIT_REPO EQUAL 0)
else (GIT_FOUND)
      SET(MusE_GITSTRING "")
endif (GIT_FOUND)


option ( ENABLE_RTAUDIO     "Multi platform rtaudio audio compatibility fallback" ON)
option ( ENABLE_ALSA         "Enable Advanced Linux Sound Architecture (ALSA)" ON)
option ( ENABLE_LASH         "Enable LASH Audio Session Handler (or LADISH compatibility layer)"     ON)
option ( ENABLE_LRDF         "Enable LADSPA RDF (lrdf) Provides extra info for LADSPA plugins"  ON)
option ( ENABLE_OSC          "Enable Lightweight Open Sound Control (liblo) (DSSI also recommended)"  ON)
option ( ENABLE_DSSI         "Enable Disposable Soft Synth Interface (dssi) (OSC also needed)" ON)

# Disabled but kept in case anyone really wants it. To tempting for users to set it.
# This is soooo old. The code is unlikely to work. It involved fst.
# option ( ENABLE_VST          "Enable VST/win support (deprecated)"                                OFF)

option ( ENABLE_VST_NATIVE   "Enable Native VST support (see ENABLE_VST_VESTIGE and VST_HEADER_PATH)" ON)
option ( ENABLE_VST_VESTIGE  "Set VST header type is Vestige"                                         ON)
option ( ENABLE_LV2          "Enable LV2 plugins and synths support" ON)
option ( ENABLE_LV2_GTK2     "Enable LV2 user interface GTK2 support" ON)

# Disabled but kept in case anyone really wants it.
# It's just too undesirable for most users, and some packagers were trying to turn it on.
# Even if we were to hide the option but make it still valid, these older package scripts would set it.
# The thing is, the code is (was) a fine working example of how to implement makepath especially for MusE,
#  so it is of importance. But very tedious and radically disruptive to a configuration to test and
#  maintain switching back and forth between set and clear. And it is most desirable to leave it off.
# So let's just really hide it for now. Tim.
## option ( ENABLE_LV2_MAKE_PATH "Enable LV2 makePath support. Stores plugin config files separate from song. NOT RECOMMENDED." OFF)

option ( ENABLE_LV2_DEBUG    "Enable LV2 debugging messages" OFF)
option ( ENABLE_FLUID        "Enable fluidsynth softsynth plugins."                                ON)
option ( ENABLE_RUBBERBAND   "Enable RubberBand Audio Stretcher/Pitch Shifter/Sample Rate Converter" ON)
#option ( ENABLE_ZITA_RESAMPLER "Enable Zita Resampler Audio Sample Rate Converter" ON)  # TODO See below...
option ( ENABLE_MIDNAM       "Enable MIDI Name support (MidNam). Official MMA instrument spec. Also for LV2 plugins." ON)
option ( ENABLE_INSTPATCH    "Enable Instrument Patch Library support (enhances soundfont support)." ON)

# Disabled but kept in case anyone really wants it.
## option ( ENABLE_EXPERIMENTAL "Enable various experimental features (not recommended)."              OFF)

# This was recently extensively overhauled, modernized, and tested. It used to be marked as experimental.
# But lest users feel cheated out of the full experience by a default build, let's set it.
# If security is of concern, users must start with a command-line option anyway for it to
#  even attempt to connect to a server. If Python is not found, no big deal.
option ( ENABLE_PYTHON       "Enable python control support."         ON)

option ( UPDATE_TRANSLATIONS "Update source translation share/locale/*.ts files (WARNING: This will modify the .ts files in the source tree!!)" OFF)
option ( MODULES_BUILD_STATIC "Build type of internal modules"                                   OFF)



if ( MODULES_BUILD_STATIC )
      SET(MODULES_BUILD STATIC )
else ( MODULES_BUILD_STATIC )
      SET(MODULES_BUILD SHARED )
#       SET(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
#       SET(CMAKE_INSTALL_RPATH ${MusE_MODULES_DIR})
endif ( MODULES_BUILD_STATIC )
# We need these always, for a few of the shared modules in the muse/core build,
#  even when building muse/core as static. Otherwise it can't find them on run. Tim.
SET(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
SET(CMAKE_INSTALL_RPATH ${MusE_MODULES_DIR})

##
## Just print a notice if this is OS X
##
if (APPLE)
	message("OS X found.")
else (APPLE)
	if (UNIX)
		message("Unix (probably linux) found")
	endif(UNIX)

endif (APPLE)

##
##  look for thread support
##

set(CMAKE_THREAD_PREFER_PTHREAD On)
find_package(Threads REQUIRED)

##
##  look for Qt5
##


set(QT_MIN_VERSION "5.7.0")
set(QT_USE_QTXML TRUE)
set(QT_USE_QTDESIGNER TRUE)
set(QT_USE_QTSVG TRUE)

find_package(Qt5Widgets)

if (NOT Qt5Widgets_FOUND)
      message(FATAL_ERROR "Fatal error: QT (version >= 5.7.0) required.\n"
      "Cmake tries to detect QT5 by searching for 'Qt5Widgets' package\n"
      "If you have QT5 installed, make sure 'Qt5Widgets' package is in PKG_CONFIG_PATH."
      )
endif (NOT Qt5Widgets_FOUND)

find_package(Qt5Core REQUIRED)
find_package(Qt5UiTools REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Svg REQUIRED)

# Needed for plugins factory:
SET(QT_USE_QTUITOOLS TRUE)

include_directories (${Qt5Widgets_INCLUDE_DIRS})
include_directories (${Qt5Core_INCLUDE_DIRS})
include_directories (${Qt5UiTools_INCLUDE_DIRS})
include_directories (${Qt5Xml_INCLUDE_DIRS})
include_directories (${Qt5Svg_INCLUDE_DIRS})

LINK_DIRECTORIES(${Qt5Widgets_LIBRARY_DIRS})
LINK_DIRECTORIES(${Qt5Core_LIBRARY_DIRS})
LINK_DIRECTORIES(${Qt5UiTools_LIBRARY_DIRS})
LINK_DIRECTORIES(${Qt5Xml_LIBRARY_DIRS})
LINK_DIRECTORIES(${Qt5Svg_LIBRARY_DIRS})

SET(QT_LIBRARIES ${Qt5Widgets_LIBRARIES} ${Qt5UiTools_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5Svg_LIBRARIES} ${Qt5Core_LIBRARIES})


##include(${QT_USE_FILE})

##
##   Begin MANDATORY packages...
##

##
## find ladspa.h
##

CHECK_INCLUDE_FILE(ladspa.h HAVE_LADSPA_H)
if(NOT HAVE_LADSPA_H)
      message(FATAL_ERROR "** ERROR: header file ladspa.h is required, but was not found."
        ${HAVE_LADSPA_H})
endif(NOT HAVE_LADSPA_H)

# ##
# ## alsa >= 0.9.0
# ##
#
# if (APPLE)
# 	message("Disabling ALSA support due to OS X build.")
# else (APPLE)
# PKG_CHECK_MODULES(ALSA REQUIRED alsa>=0.9.0)
# include_directories(${ALSA_INCLUDE_DIRS})
# endif (APPLE)

##
## find sndfile >= 1.0.0
##

PKG_CHECK_MODULES(SNDFILE REQUIRED sndfile>=1.0.0)
include_directories(${SNDFILE_INCLUDE_DIRS})

##
## find libsamplerate >= 0.1.0
##

PKG_CHECK_MODULES(SAMPLERATE REQUIRED samplerate>=0.1.0)
include_directories(${SAMPLERATE_INCLUDE_DIRS})

##
## find jack >= 0.103.0
##

PKG_CHECK_MODULES(JACK REQUIRED jack>=0.103)
include_directories(${JACK_INCLUDE_DIRS})

##
##   End MANDATORY packages.
##

##
##   Begin OPTIONAL packages...
##

# Check for GNU-specific math support:

=== muse3/al/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 1999-2011 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##
file (GLOB al_source_files
      al.cpp
      dsp.cpp
      sig.cpp
      xml.cpp
      )
if (USE_SSE)
      file (GLOB al_source_files
      ${al_source_files}
      dspSSE.cpp
      dspXMM.cpp
      )
endif (USE_SSE)

##
## Define target
##
add_library(al ${MODULES_BUILD}
      ${al_source_files}
      )

##
## Compilation flags and target name
##
set_target_properties( al
      PROPERTIES OUTPUT_NAME muse_al
      )
set_source_files_properties(
      dspSSE.cpp
      PROPERTIES COMPILE_FLAGS "-x assembler"
      )

##
## Linkage
##
target_link_libraries ( al
      ${QT_LIBRARIES}
      )

##
## Install location
##
if ( ${MODULES_BUILD} STREQUAL SHARED )
      install(TARGETS al 
            DESTINATION ${MusE_MODULES_DIR}
            )
endif ( ${MODULES_BUILD} STREQUAL SHARED )

=== muse3/audio_convert/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  audio_convert/CMakeLists.txt
#  (C) Copyright 2016 Tim E. Real (terminator356 A T sourceforge D O T net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

add_subdirectory(lib_audio_convert)
add_subdirectory(src_resampler)
add_subdirectory(zita_resampler)
add_subdirectory(rubberband)


include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##
file (GLOB audio_convert_source_files
      audio_converter_plugin.cpp
      audio_converter_settings_group.cpp
      )

##
## Define target
##
add_library(audio_converter_plugin ${MODULES_BUILD}
      ${audio_convert_source_files}
      )

##
## Linkage
##
target_link_libraries(audio_converter_plugin
      xml_module
      dl
      )
##
## Append to the list of translations
##
set (FILES_TO_TRANSLATE
      ${FILES_TO_TRANSLATE}
      ${audio_convert_source_files}
      CACHE INTERNAL ""
      )

##
## Compilation flags and target name
##
# set_target_properties( audio_converter_plugin
#       PROPERTIES
#       ## OUTPUT_NAME muse_audio_converter_plugin
#       )

##
## Install location
##
if ( ${MODULES_BUILD} STREQUAL SHARED )
      install(TARGETS audio_converter_plugin
            DESTINATION ${MusE_MODULES_DIR}
            )
endif ( ${MODULES_BUILD} STREQUAL SHARED )

=== muse3/grepmidi/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 1999-2011 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

##
## List of source files to compile
##
file (GLOB grepmidi_source_files
      grepmidi.cpp
      )

##
## Define target
##
add_executable ( grepmidi
      ${grepmidi_source_files}
      )

##
## Install location
##
install(TARGETS grepmidi 
      DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
      )

=== muse3/libs/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  CMakeLists.txt
#  (C) Copyright 2014 Tim E. Real (terminator356 on users dot sourceforge dot net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

subdirs(evdata memory midi_controller midnam mpevent string sysex_helper xml time_stretch wave plugin)

=== muse3/muse/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 1999-2011 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

include_directories(
      ${CMAKE_CURRENT_BINARY_DIR}
      )

set (SubDirs
      widgets
      mplugins
      components
      arranger
      cliplist
      ctrl
      driver
      function_dialogs
      instruments
      liste
      marker
      master
      midiedit
      mixer
      waveedit
      )
if(LV2_SUPPORT)
  if(HAVE_GTK2)
    set ( SubDirs ${SubDirs} lv2Gtk2Support )
  endif(HAVE_GTK2)
endif(LV2_SUPPORT)

if (PYTHON_SUPPORT)
      set ( REM_LIB remote )
      set ( SubDirs ${SubDirs} remote )
endif (PYTHON_SUPPORT)

subdirs (${SubDirs})

##
## Expand Qt macros in source files
##
QT5_WRAP_CPP ( muse_moc_headers
      app.h
      cobject.h
      conf.h
      midieditor.h
      midi_editor_layout.h
      plugin.h
      script_delivery.h
      song.h
      transport.h
      value.h
      steprec.h
      vst_native.h
      )

QT5_WRAP_CPP ( wavepreview_moc_headers
      wavepreview.h
      )

##
## Resource files
##
QT5_ADD_RESOURCES (muse_qrc_files
#		  muse.qrc
		  ../resources.qrc
		  )

file (GLOB core_source_files
      app.cpp
      audio.cpp
      audio_fifo.cpp
      audioprefetch.cpp
      audiotrack.cpp
      cobject.cpp
      conf.cpp
      controlfifo.cpp
      ctrl.cpp
      dialogs.cpp
      dssihost.cpp
      event.cpp
      eventlist.cpp
      event_tag_list.cpp
      exportmidi.cpp
      functions.cpp
      gconfig.cpp
      globals.cpp
      help.cpp
      helper.cpp
      importmidi.cpp
      key.cpp
      keyevent.cpp
      metronome_class.cpp
      midi.cpp
      midictrl.cpp
      mididev.cpp
      midieditor.cpp
      midi_editor_layout.cpp
      midievent.cpp
      midifile.cpp
      midiport.cpp
      midiseq.cpp
      mtc.cpp
      name_factory.cpp
      node.cpp
      operations.cpp
      osc.cpp
      part.cpp
      plugin.cpp
      pluglist.cpp
      pos.cpp
      route.cpp
      script_delivery.cpp
      seqmsg.cpp
      shortcuts.cpp
      sig.cpp
      song.cpp
      songfile.cpp
      songfile_discovery.cpp
      stringparam.cpp
      sync.cpp
      synth.cpp
      tempo.cpp
      thread.cpp
      ticksynth.cpp
      track.cpp
      transport.cpp
      transport_obj.cpp
      undo.cpp
      value.cpp
      vst.cpp
      vst_native.cpp
      wave_helper.cpp
      waveevent.cpp
      wavetrack.cpp
      steprec.cpp
      )
file (GLOB main_source_files
      main.cpp
      )
file (GLOB icons_source_files
      icons.cpp
      )

file (GLOB latency_compensator_source_files
      latency_info.cpp
      latency_compensator.cpp
      )
file (GLOB wavepreview_source_files
      wavepreview.cpp
      )

##
## Define target
##

add_library ( latency_compensator_module SHARED
      ${latency_compensator_source_files}
      )
add_library ( wavepreview_module SHARED
      ${wavepreview_moc_headers}
      ${wavepreview_source_files}
      )

add_library ( core ${MODULES_BUILD}
      ${muse_moc_headers}
      ${core_source_files}
      )
add_executable ( muse
      ${main_source_files}
      ${muse_qrc_files}
      )
add_library ( icons ${MODULES_BUILD}
      ${icons_source_files}
      )

set (FILES_TO_TRANSLATE
      ${FILES_TO_TRANSLATE}
      ${main_source_files}
      ${core_source_files}
      CACHE INTERNAL ""
      )

##
## Directories that will be passed to the compiler with -I flag
##
include_directories (
      arranger
      cliplist
      components
      driver
      function_dialogs
      instruments
      liste
      midiedit
      mixer
      mplugins
      remote
      waveedit
      widgets
      lv2Support
      )

# Make sure to include the uic generated headers paths.
include_directories(
      ${CMAKE_CURRENT_BINARY_DIR}/arranger
      ${CMAKE_CURRENT_BINARY_DIR}/cliplist
      ${CMAKE_CURRENT_BINARY_DIR}/driver
      ${CMAKE_CURRENT_BINARY_DIR}/instruments
      ${CMAKE_CURRENT_BINARY_DIR}/liste
      ${CMAKE_CURRENT_BINARY_DIR}/midiedit
      ${CMAKE_CURRENT_BINARY_DIR}/mixer
      ${CMAKE_CURRENT_BINARY_DIR}/mplugins
      ${CMAKE_CURRENT_BINARY_DIR}/remote
      ${CMAKE_CURRENT_BINARY_DIR}/waveedit
      ${CMAKE_CURRENT_BINARY_DIR}/widgets
      ${CMAKE_CURRENT_BINARY_DIR}/components
      ${CMAKE_CURRENT_BINARY_DIR}/function_dialogs
      )

##
## Compilation flags and target name
##
set_target_properties( core
      PROPERTIES COMPILE_FLAGS "${VST_SDK_QUIRK}"
      OUTPUT_NAME muse_core
      )
set_target_properties( muse
      PROPERTIES OUTPUT_NAME ${MusE_EXEC_NAME}
      )
set_target_properties( icons
      PROPERTIES OUTPUT_NAME muse_icons
      )

set_target_properties( latency_compensator_module
      PROPERTIES OUTPUT_NAME muse_latency_compensator_module
      )
set_target_properties( wavepreview_module
      PROPERTIES OUTPUT_NAME muse_wavepreview_module
      )
      
##
## Linkage
##

target_link_libraries(wavepreview_module
      ${QT_LIBRARIES}
      ${SNDFILE_LIBRARIES}
      ${SAMPLERATE_LIBRARIES}
      )

      
target_link_libraries(core
      al
      arranger
      audio_converter_plugin
      cliplist
      ctrl
      driver
      evdata_module
      icons
      instruments
      latency_compensator_module
      liste
      marker
      master
      memory_module
      midiedit
      midi_controller_module
      mixer
      mpevent_module
      mplugins
      muse_string
      plugin_scan_module
      plugin_cache_writer_module
      Threads::Threads
      synti
      sysex_helper_module
      time_stretch_module
      wave_module
      waveedit
      wavepreview_module
      widgets
      components
      widgets_functiondialogs
      xml_module

      ${QT_LIBRARIES}
      ## Bring in the dssi alsa compatibility libraries if required
      ${DSSI_ALSA_COMPAT_LIBRARIES}
      ${SNDFILE_LIBRARIES}
      # Note that this also appears in the audio_convert/src_resampler shared library.
      ${SAMPLERATE_LIBRARIES}
      ${REM_LIB}
      ${FST_LIB}
      dl
      )

if(HAVE_LASH)
      target_link_libraries(core ${LASH_LIBRARIES})
endif(HAVE_LASH)

if(OSC_SUPPORT)
      target_link_libraries(core ${LIBLO_LIBRARIES})
endif(OSC_SUPPORT)

if(MIDNAM_SUPPORT)
      target_link_libraries(core midnam_module)
endif(MIDNAM_SUPPORT)

# Certain warnings in lv2 headers are causing errors with recent gcc.
# It seems there's no way to suppress -Werror from within code.
# The slightest warning in some header file can now trigger an error.
# Gcc help warns that only some warnings can be suppressed.
# 'pragma GCC diagnostic ignored "-Wparentheses"' didn't work.
# Looks like no choice but to make the lv2host a module with separate flags.
#     
if(LV2_SUPPORT)
      ##
      ## Expand Qt macros in source files
      ##
      QT5_WRAP_CPP ( lv2host_moc_headers
            lv2host.h
            )
      file (GLOB lv2host_source_files
            lv2host.cpp
            )
      add_library ( lv2host_module ${MODULES_BUILD}
            ${lv2host_moc_headers}
            ${lv2host_source_files}
            )
      set_target_properties( lv2host_module
            # Avoid treating warnings as errors here, unlike the rest of the app.
            PROPERTIES COMPILE_FLAGS "-Wno-error"
            OUTPUT_NAME muse_lv2host_module
            )
            
      target_link_libraries(lv2host_module ${LILV_LIBRARIES})
      target_link_libraries(lv2host_module ${SORD_LIBRARIES})
      target_link_libraries(lv2host_module ${LV2_LIBRARIES})
      
      if(HAVE_GTK2)
            target_link_libraries(lv2host_module lv2_gtk2_support)
      endif(HAVE_GTK2)

      target_link_libraries(lv2host_module ${QT_LIBRARIES})
      if(MIDNAM_SUPPORT)
            target_link_libraries(lv2host_module midnam_module)
      endif(MIDNAM_SUPPORT)
      target_link_libraries(lv2host_module midi_controller_module)
      target_link_libraries(core lv2host_module)
endif(LV2_SUPPORT)



target_link_libraries(muse
      midiedit
      core
      )

target_link_libraries(icons
      ${QT_LIBRARIES}
      )

##
## Install location
##
install( TARGETS muse
      RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/
      )
      
install(TARGETS
        latency_compensator_module
        wavepreview_module
      DESTINATION ${MusE_MODULES_DIR}
      )
      
if ( ${MODULES_BUILD} STREQUAL SHARED )
      install(TARGETS core icons 
              # latency_compensator_module
            DESTINATION ${MusE_MODULES_DIR}
            )
      # This conditional fixes an error when LV2_SUPPORT is false:
      #  "install TARGETS given target "lv2host_module" which does not exist."
      if (LV2_SUPPORT)
        install ( TARGETS lv2host_module DESTINATION ${MusE_MODULES_DIR} )
      endif (LV2_SUPPORT)
              
endif ( ${MODULES_BUILD} STREQUAL SHARED )

=== muse3/packaging/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 1999-2011 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

#
# produce the .desktop file
#
configure_file (
      org.musesequencer.Muse3.desktop.in
      ${PROJECT_BINARY_DIR}/packaging/org.musesequencer.Muse3.desktop
      )

#
# install the appdata, desktop and mime files
#
install( FILES org.musesequencer.Muse3.png
      DESTINATION ${SHARE_INSTALL_PREFIX}/icons/hicolor/64x64/apps/
      )
install( FILES ${PROJECT_BINARY_DIR}/packaging/org.musesequencer.Muse3.desktop
      DESTINATION ${SHARE_INSTALL_PREFIX}/applications/
      )
install( FILES muse.xml
      DESTINATION ${SHARE_INSTALL_PREFIX}/mime/packages/
      )
install( FILES org.musesequencer.Muse3.appdata.xml
      DESTINATION ${SHARE_INSTALL_PREFIX}/metainfo/
      )

=== muse3/audio_convert/lib_audio_convert/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  lib_audio_convert/CMakeLists.txt
#  (C) Copyright 2016 Tim E. Real (terminator356 A T sourceforge D O T net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##
file (GLOB audio_convert_source_files
      audioconvert.cpp
      )

##
## Define target
##
add_library(audio_convert ${MODULES_BUILD}
      ${audio_convert_source_files}
      )

##
## Append to the list of translations
##
set (FILES_TO_TRANSLATE
      ${FILES_TO_TRANSLATE}
      ${audio_convert_source_files}
      CACHE INTERNAL ""
      )

##
## Compilation flags and target name
##
set_target_properties( audio_convert
      PROPERTIES
      OUTPUT_NAME muse_audio_convert
      )

##
## Linkage
##
target_link_libraries(audio_convert
      time_stretch_module
      xml_module
      ${SNDFILE_LIBRARIES}
      )

##
## Install location
##
if ( ${MODULES_BUILD} STREQUAL SHARED )
      install(TARGETS audio_convert
            DESTINATION ${MusE_MODULES_DIR}
            )
endif ( ${MODULES_BUILD} STREQUAL SHARED )

=== muse3/libs/evdata/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  evdata/CMakeLists.txt
#  (C) Copyright 2018 Tim E. Real (terminator356 on users dot sourceforge dot net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##

file (GLOB evdata_source_files
      evdata.cpp
      )

##
## Define target
##

add_library ( evdata_module SHARED
      ${evdata_source_files}
      )

##
## Compilation flags and target name
##

set_target_properties( evdata_module
      PROPERTIES OUTPUT_NAME muse_evdata_module
      )

##
## Linkage
##

target_link_libraries(evdata_module
      memory_module
      sysex_helper_module
      )

##
## Install location
##

install(TARGETS
        evdata_module
      DESTINATION ${MusE_MODULES_DIR}
      )

# if ( ${MODULES_BUILD} STREQUAL SHARED )
#       install(TARGETS
#             evdata_module
#             DESTINATION ${MusE_MODULES_DIR}
#             )
# endif ( ${MODULES_BUILD} STREQUAL SHARED )

=== muse3/libs/memory/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  memory/CMakeLists.txt
#  (C) Copyright 2018 Tim E. Real (terminator356 on users dot sourceforge dot net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##

file (GLOB memory_source_files
      memory.cpp
      )

##
## Define target
##

add_library ( memory_module SHARED
      ${memory_source_files}
      )

##
## Compilation flags and target name
##

set_target_properties( memory_module
      PROPERTIES OUTPUT_NAME muse_memory_module
      )

##
## Linkage
##

# target_link_libraries(memory_module
#       )

##
## Install location
##

install(TARGETS
        memory_module 
      DESTINATION ${MusE_MODULES_DIR}
      )

# if ( ${MODULES_BUILD} STREQUAL SHARED )
#       install(TARGETS
#             memory_module
#             DESTINATION ${MusE_MODULES_DIR}
#             )
# endif ( ${MODULES_BUILD} STREQUAL SHARED )

=== muse3/libs/midi_controller/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  midi_controller/CMakeLists.txt
#  (C) Copyright 2020 Tim E. Real (terminator356 on users dot sourceforge dot net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##

file (GLOB midi_controller_source_files
      midi_controller.cpp
      )

##
## Define target
##

add_library ( midi_controller_module SHARED
      ${midi_controller_source_files}
      )

##
## Compilation flags and target name
##

set_target_properties( midi_controller_module
      PROPERTIES OUTPUT_NAME muse_midi_controller_module
      )

target_link_libraries(midi_controller_module
      xml_module
      ${QT_LIBRARIES}
      )

##
## Install location
##

install(TARGETS
      midi_controller_module
      DESTINATION ${MusE_MODULES_DIR}
      )

=== muse3/libs/midnam/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#
#  midname/CMakeLists.txt
#  (C) Copyright 2019 Tim E. Real (terminator356 on users dot sourceforge dot net)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the
#  Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
#=============================================================================

include(${PROJECT_SOURCE_DIR}/pch.txt)

##
## List of source files to compile
##

file (GLOB midnam_source_files
      midnam.cpp
      )

##
## Define target
##

add_library ( midnam_module SHARED
      ${midnam_source_files}
      )

##
## Compilation flags and target name
##

set_target_properties( midnam_module
      PROPERTIES OUTPUT_NAME muse_midnam_module
      )

target_link_libraries(midnam_module
      xml_module
      midi_controller_module
      mpevent_module
      ${QT_LIBRARIES}
      )

##
## Install location
##

install(TARGETS
        midnam_module
      DESTINATION ${MusE_MODULES_DIR}
      )

=== debian/changelog ===
muse (3.1.1-1) unstable; urgency=medium

  [ Olivier Humbert ]
  * Update d/control:Homepage
  * Update d/control:Description : mention LV2
  * Update d/control:Description : add a mention for DSSI

  [ Dennis Braun ]
  * New upstream version 3.1.1
    + No ds tag anymore, muse/lv2Support/* is removed by upstream
  * Update patchset, almost everything applied by upstream
  * Build in new sourcedir muse3
  * Add hardening
  * Add me as uploader
  * Bump dh-compat to 13
  * Bump S-V to 4.5.0
  * Update d/copyright
  * d/gbp.conf: Remove incorrect compression setting
  * Add lintian overrides
  * Remove obsolete d/source/local-options
  * Add d/upstream/metadata
  * Fix d/watch

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 19 Oct 2020 16:42:13 +0200

=== debian/control ===
Source: muse
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Fabrice Coutadeur <coutadeurf@gmail.com>,
 Dennis Braun <d_braun@kabelmail.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dssi-dev,
 libasound2-dev,
 libdssialsacompat-dev [!linux-any],
 libfluidsynth-dev,
 libjack-dev,
 liblilv-dev (>= 0.22),
 liblo-dev,
 libqt5svg5-dev,
 libsamplerate0-dev,
 libsndfile1-dev,
 libsord-dev (>= 0.14),
 lv2-dev (>= 1.12),
 qtbase5-dev,
 qttools5-dev
Standards-Version: 4.5.0
Homepage: https://muse-sequencer.github.io/
Vcs-Git: https://salsa.debian.org/multimedia-team/muse.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/muse
Rules-Requires-Root: no

Package: muse
Architecture: any
Depends:
 python3,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 jackd
Description: Qt-based audio/MIDI sequencer
 MusE is a MIDI/audio sequencer with recording and editing capabilities.
 Some Highlights:
 .
  * Standard midifile (smf) import-/export.
  * Organizes songs in tracks and parts which you can arrange with
    the part editor.
  * MIDI editors: pianoroll, drum, list, controller.
  * Score editor with high quality postscript printer output.
  * Realtime: editing while playing.
  * Unlimited number of open editors.
  * Unlimited undo/redo.
  * Realtime and step-recording.
  * Multiple MIDI devices.
  * Unlimited number of tracks.
  * Sync to external devices: MTC/MMC, Midi Clock, Master/Slave.
  * Audio tracks, LV2/DSSI/LADSPA host for master effects.
  * Multithreaded.
  * Uses raw MIDI devices.
  * XML project file.
  * Project file contains complete app state (session data).
  * Application spanning Cut/Paste Drag/Drop.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Dmuse3

override_dh_clean:
	dh_clean -Xmuse/widgets/arrangercolumns.cpp~ \
		-Xmuse/widgets/arrangercolumns.h~ -X*~

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_INSTALL_DIR=/usr/lib

override_dh_install:
	dh_install -pmuse
	find $(CURDIR)/debian/muse/ -name "COPYING*" -delete
	find $(CURDIR)/debian/muse/ -name "LICENSE" -delete
	find $(CURDIR)/debian/muse/ -name "ChangeLog*" -delete
	cd $(CURDIR)/debian/muse/usr/share/doc/muse && \
		mv muse_html/single/documentation/ html/ && \
		rm -rf muse_html

=== debian/watch ===
version=4
opts="" \
    https://github.com/muse-sequencer/muse/tags .*/muse_(\d+)_(\d+)_(\d+)\.tar\.gz
